    View Javadoc
    1   package org.apache.bcel.classfile;
    2
    3   /* ====================================================================
    4    * The Apache Software License, Version 1.1
    5    *
    6    * Copyright (c) 2001 The Apache Software Foundation.  All rights
    7    * reserved.
    8    *
    9    * Redistribution and use in source and binary forms, with or without
    10   * modification, are permitted provided that the following conditions
    11   * are met:
    12   *
    13   * 1. Redistributions of source code must retain the above copyright
    14   *    notice, this list of conditions and the following disclaimer.
    15   *
    16   * 2. Redistributions in binary form must reproduce the above copyright
    17   *    notice, this list of conditions and the following disclaimer in
    18   *    the documentation and/or other materials provided with the
    19   *    distribution.
    20   *
    21   * 3. The end-user documentation included with the redistribution,
    22   *    if any, must include the following acknowledgment:
    23   *       "This product includes software developed by the
    24   *        Apache Software Foundation (http://www.apache.org/)."
    25   *    Alternately, this acknowledgment may appear in the software itself,
    26   *    if and wherever such third-party acknowledgments normally appear.
    27   *
    28   * 4. The names "Apache" and "Apache Software Foundation" and
    29   *    "Apache BCEL" must not be used to endorse or promote products
    30   *    derived from this software without prior written permission. For
    31   *    written permission, please contact apache@apache.org.
    32   *
    33   * 5. Products derived from this software may not be called "Apache",
    34   *    "Apache BCEL", nor may "Apache" appear in their name, without
    35   *    prior written permission of the Apache Software Foundation.
    36   *
    37   * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
    38   * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
    39   * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    40   * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
    41   * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    42   * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    43   * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
    44   * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
    45   * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    46   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    47   * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    48   * SUCH DAMAGE.
    49   * ====================================================================
    50   *
    51   * This software consists of voluntary contributions made by many
    52   * individuals on behalf of the Apache Software Foundation.  For more
    53   * information on the Apache Software Foundation, please see
    54   * <http://www.apache.org/>;.
    55   */
    56
    57  import  org.apache.bcel.Constants;
    58  import  java.io.*;
    59
    60  /***
    61   * This class is derived from the abstract
    62   * <A HREF="org.apache.bcel.classfile.Constant.html">Constant</A> class
    63   * and represents a reference to a Double object.
    64   *
    65   * @version $Id: ConstantDouble.java,v 1.2 2002/03/11 16:16:35 mdahm Exp $
    66   * @author  <A HREF="mailto:markus.dahm@berlin.de">M. Dahm</A>
    67   * @see     Constant
    68   */
    69  public final class ConstantDouble extends Constant implements ConstantObject {
    70    private double bytes;
    71
    72    /***
    73     * @param bytes Data
    74     */
    75    public ConstantDouble(double bytes) {
    76      super(Constants.CONSTANT_Double);
    77      this.bytes = bytes;
    78    }
    79
    80    /***
    81     * Initialize from another object.
    82     */
    83    public ConstantDouble(ConstantDouble c) {
    84      this(c.getBytes());
    85    }
    86
    87    /***
    88     * Initialize instance from file data.
    89     *
    90     * @param file Input stream
    91     * @throws IOException
    92     */
    93    ConstantDouble(DataInputStream file) throws IOException
    94    {
    95      this(file.readDouble());
    96    }
    97
    98    /***
    99     * Called by objects that are traversing the nodes of the tree implicitely
    100    * defined by the contents of a Java class. I.e., the hierarchy of methods,
    101    * fields, attributes, etc. spawns a tree of objects.
    102    *
    103    * @param v Visitor object
    104    */
    105   public void accept(Visitor v) {
    106     v.visitConstantDouble(this);
    107   }
    108   /***
    109    * Dump constant double to file stream in binary format.
    110    *
    111    * @param file Output file stream
    112    * @throws IOException
    113    */
    114   public final void dump(DataOutputStream file) throws IOException
    115   {
    116     file.writeByte(tag);
    117     file.writeDouble(bytes);
    118   }
    119   /***
    120    * @return data, i.e., 8 bytes.
    121    */
    122   public final double getBytes() { return bytes; }
    123   /***
    124    * @param bytes.
    125    */
    126   public final void setBytes(double bytes) {
    127     this.bytes = bytes;
    128   }
    129   /***
    130    * @return String representation.
    131    */
    132   public final String toString()
    133   {
    134     return super.toString() + "(bytes = " + bytes + ")";
    135   }
    136
    137   /*** @return Double object
    138    */
    139   public Object getConstantValue(ConstantPool cp) {
    140     return new Double(bytes);
    141   }
    142 }

This page was automatically generated by Maven